<?
class View extends Object {

    static protected $tpl;
    static protected $values;
    static protected $blocks;
    static protected $compile;
    static public $template = 'main';
    static public $path = '';
    
    /**
     *   
     */
    function SetTemplate ($name) {
        self::$template = $name;
    }
    
    /**
     *      
     */
    function SetPath ($name) {
        if ($name != '') {
            self::$path = $name.'/';
        }
        else {
            self::$path = '';
        }   
    }
    
    /**
     *  
     */
    function load ($name) {   
        self::$tpl[$name] = file_get_contents(ROOT_DIR. '/templates/'. THEME .'/'. self::$path. $name. '.tpl');        
    }
    
    /**
     *      
     */
    function assign ($tpl, $name, $value) {   
        self::$values[$tpl][$name] = $value;                   
    }
    
    /**
     *       
     */
    function assign_array($tpl, $array) {       
        foreach ($array AS $name => $value) {
            self::$values[$tpl][$name] = $value;
        }                
    }
    
    /**
     *  
     */
    function add_block ($tpl, $find, $replace) {        
        self::$blocks[$tpl][$find] = $replace;  
    }
        
    /**
     *    
     */
    function build ($tpl, $empty=false) {
        
        if (Engine::GetError()) {
            self::$values[$tpl]['{content}'] = Engine::GetError();
        }
    
        self::$compile[$tpl] = self::$tpl[$tpl];
        if (self::$values[$tpl]) {
            foreach (self::$values[$tpl] AS $key => $value) {  
           
                self::$compile[$tpl] = str_replace($key, $value, self::$compile[$tpl]); 
             
            }
        } 
        if (self::$values['global']) {
            foreach (self::$values['global'] AS $key => $value) {  
           
                self::$compile[$tpl] = str_replace($key, $value, self::$compile[$tpl]); 
             
            }
        } 
        
        if (self::$blocks[$tpl]) {
            foreach (self::$blocks[$tpl] AS $key => $value) {  
                self::$compile[$tpl] = preg_replace('#'.$key.'#i', $value, self::$compile[$tpl]); 
            }

        }

        if ($empty == true) {
            
            self::$compile[$tpl] = preg_replace("#\{.*\}#", '', self::$compile[$tpl]);
            
        }
        
        self::$path = '';
        
        return self::$compile[$tpl];
        
    }

}