<?php
class tCache {

	private $_adapter;

	function __construct($_adapter) {
        
        if (!$_adapter) {
            $_adapter = 'file';
        }
        
        include('adapters/'. $_adapter .'.class.php');
        
        $this->class = new $_adapter;

	}
	
	function save($name, $data) {
        return $this->class->save($name, $data);
    }
	
	function get($name) {
        return $this->class->get($name);
    }
    
    function expired ($name, $time) {
        return $this->class->expired($name, $time);
    }
    
    function delete ($name) {
        return $this->class->delete($name);
    }
    
}