<?
class Router extends Object {
    
    static public $Action = '';
    static public $Event = '';
    static public $Params = array();
    static public $RegisterEvent = array();
    static public $RegisterEventPreg = array();
    
    /**
     * Парсит урл
     */
    static public function GetUrl ()  {
    
    	if (count(explode('.', $_SERVER['HTTP_HOST'])) > 2) {
    		self::UrlAlias();	
    	}
    	else {
    		
    		$url = preg_replace("/\/+/", '/', $_SERVER['REQUEST_URI']);
        	$url = str_replace(SITE_PATH, '', $url);		
        	$url = preg_replace("/^\/(.*)\/?$/U", '\\1', $url);
        	$url = preg_replace("/^(.*)\/\?.*$/U", '\\1', $url);
        	$urls = explode('/', $url);
        
       		self::$Action = array_shift($urls);
       		self::$Event = array_shift($urls);
        	self::$Params = $urls;
        	
    	}
    	   
    }
    
    /**
     * Загружает экшен
     */
    static public function LoadActionClass () {
        
        // Определяем и подгружаем текущий экшен
        if (!self::$Action) {
            self::$Action = DEFAULT_ACTION;
        }
        elseif (!file_exists(ROOT_DIR .'/engine/actions/'. self::$Action .'.php')) {
            self::$Action = 'error';
        }
        
        include(ROOT_DIR .'/engine/actions/'. self::$Action .'.php');
        
        // Подгружаем его класс, если существует
        Engine::LoadClass(Router::$Action);
     
        // Создаем обьект экшена
        $action = new self::$Action;
        $action->_load();
        
        Action::ExecEvent($action);

    }
    
    /**
     * Переадресовывает на нужный урл
     */
    static public function Location ($url) {
        die('<script type="text/javascript">document.location.href="'. $url .'"</script>');       
    }
    
    /**
     * Парсит субдомены и сравнивает значение с конфигом
     */
    static public function UrlAlias () {
    	
    	$url = preg_replace("/\/+/", '/', $_SERVER['REQUEST_URI']);
        $url = str_replace(SITE_PATH, '', $url);		
        $url = preg_replace("/^\/(.*)\/?$/U", '\\1', $url);
        $url = preg_replace("/^(.*)\/\?.*$/U", '\\1', $url);
        $urls = explode('/', $url);
    	
    	include(ROOT_DIR.'/engine/config/alias.php');
    	$sub = explode('.', $_SERVER['HTTP_HOST']);
    	if ($alias[$sub['0']]) {
    		
    		if ($alias[$sub['0']]['type'] == 'event') {
    			self::$Action = $alias[$sub['0']]['action'];
    			self::$Event = $sub['0'];
    		}
    		else {
    			self::$Action = $alias[$sub['0']]['action'];
    			self::$Event = array_shift($urls);
    		}
    		
    	}
    	else {
    		
    		if ($alias['*']['type'] == 'event') {
    			self::$Action = $alias['*']['action'];
    			self::$Event = $sub['0'];
    		}
    		else {
    			self::$Action = $alias['*']['action'];
    			self::$Event = array_shift($urls);
    		}
    		
    	}

        self::$Params = $urls;
    	
    }
    
}